var timer1;
var timerNext
var FrameworkApp = angular.module('Framework', [
    'ui.router', 'ui.bootstrap', 'ui.knob', 'ngTouch', 'angular-bootstrap-select', 'vAccordion', 'angular-carousel-3d'
    // , 'rzModule'
    , 'angular-carousel-3dtext', 'ngSanitize', 'ngDragDrop', 'rzSlider'
]);

////////////////////////////////////////////////////////
//Module config
////////////////////////////////////////////////////////
FrameworkApp.config(['$stateProvider', '$urlRouterProvider', '$locationProvider', function($stateProvider, $urlRouterProvider, $locationProvider) {
    $stateProviderReference = $stateProvider;
    $urlRouterProviderReference = $urlRouterProvider;
}]);

////////////////////////////////////////////////////////
//Module run
////////////////////////////////////////////////////////
FrameworkApp.run(['$rootScope', '$state', '$stateParams', '$location', '$http', '$timeout', 'PreloaderService', '$modal', '$interval', function($rootScope, $state, $stateParams, $location, $http, $timeout, PreloaderService, $modal, $interval) {
    $rootScope.$state = $state;
    $rootScope.disableButton = false;
    $rootScope.headerValue = false;
    $rootScope.footerPointValue = false;
    $rootScope.footerProgressBar = false;
    // $rootScope.removeAnswerButton = true;
    $rootScope.$stateParams = $stateParams;
    $rootScope.slideDirection = "Next";
    $rootScope.currentModule = 0;
    $rootScope.currentTopic = 0;
    $rootScope.currentPage = 0;
    $rootScope.assesmentScore = 0
    $rootScope.asmntScoreArray = [2, 2, 2, 2, 2, 2, 2, 2, 2, 2];
    $rootScope.quizCounter = 0;
    $rootScope.totalPages = 0;
    $rootScope.videoPopup = 0;
    $rootScope.videopopupId = 1;
    $rootScope.menubutton = false;
    $rootScope.homebutton = false;
    $rootScope.disableCloseButton = true;
    $rootScope.currentPageNumber = 0;
    $rootScope.itemId = 0
    $rootScope.scoreValue2 = 0
    $rootScope.deskTop = true;
    $rootScope.pushitemIddata = [0, 0, 0]
    $rootScope.pushFeedbackdata = [0, 0, 0]
    $rootScope.pageStatusList = [];
    $rootScope.topicWiseScore = [];
    $rootScope.moduleWiseScore = [];
    $rootScope.unlockTopic = [];
    $rootScope.menuDisplay = true;
    $rootScope.unlockTopic_ref = []
    $rootScope.isPassed = [2, 2, 0, "d", false, false, 0, 'role'];
    //$rootScope.isPassed[6] for first attampt
    $rootScope.isPreLoading = true;
    $rootScope.totalNuberofQuestionAttempt = 0
    $rootScope.isPreLoadSuccessful = false;
    $rootScope.isRendered = false;
    $rootScope.percentLoaded = 0;
    $rootScope.userRole = "nEmp";
    $rootScope.isVideo = false;
    $rootScope.audioFile = ""
    $rootScope.selectedLang = "en";
    $rootScope.deviceUrl = "../html5/Views";
    $rootScope.deskTop = false;
    $rootScope.reloadAllPages = false
    $rootScope.isOnline = true;
    $rootScope.certificateViewed = false;
    $rootScope.isTranScript = false;
    $rootScope.hideAlertMenu = false;
    $rootScope.caseStudycomplatedStatusstart = [0, 0]
    $rootScope.caseStudycomplatedStatusstart1 = [0, 0]
    $rootScope.caseStudycomplatedStatus = []
    $rootScope.caseStudycomplatedStatusstart2casestudy = [0, 0, 0]
    $rootScope.casestudyArray = [0]
    if (/Android|webOS|iPhone|iPad|iPod|BlackBerry/i.test(navigator.userAgent)) {
        $rootScope.deskTop = false;
    } else {
        $rootScope.deskTop = true;
    }

    $rootScope.showcertificate = function() {
            updateAlert($rootScope.selectedLang);
            var apptype = $rootScope.CourseConfig.AppType.toLowerCase(); /* chnage apptype to scorm before uploading to lms standalone only for development */
            if (navigator.onLine) {
                // $rootScope.markVisitedPage();
                $rootScope.certificateViewed = true;
                var learnerScore;
                var learnerName;
                var strStudentId;
                if (apptype == "scorm1.2") {
                    getLMSDATAVisualMenu();
                    var dateString = getDateVisualMenu[3];
                    learnerScore = Math.round(scormAdaptor_getscore());
                    learnerName = scormAdaptor_getstudentname();
                    strStudentId = scormAdaptor_getstudentid();
                } else {
                    var currentTime = new Date();
                    var month = currentTime.getMonth() + 1;
                    var day = currentTime.getDate();
                    var year = currentTime.getFullYear();
                    var dateString = day + '/' + month + '/' + year;
                    learnerScore = "100"
                    learnerName = "Default Name"
                    strStudentId = "00001111"
                }

                $(".page-content, .course-name").hide();
                setTimeout(function() {
                    $("#certificatecontainer").show();
                }, 100);

                var strStudentName = "aaaaaaaaaa";
                if (strStudentName == "") {
                    strStudentName = "Learner Name";
                }
                $rootScope.certificateImg = $rootScope.VisualMenuContent.certificateimage_NTB;
                // if ($rootScope.userRole == "nEmp") {
                //     $rootScope.certificateImg = $rootScope.VisualMenuContent.certificateimage_NTB;
                // } else {
                //     $rootScope.certificateImg = $rootScope.VisualMenuContent.certificateimage_ETB;
                // }
                var certificatetext = new String();

                certificatetext = '';


                certificatetext += '<div id="certificateArea">'
                certificatetext += '<div id="certificate">'

                certificatetext += '<div class="bgimage"><img src="' + $rootScope.certificateImg + '"/></div>';



                certificatetext += '<div class="name">' + learnerName + '</div>';
                certificatetext += '<div class="bankId">Bank Id: ' + strStudentId + '</div>';
                certificatetext += '<div class="score">' + learnerScore + "%" + '</div>';
                certificatetext += '<div class="date">' + dateString + '</div>';
                certificatetext += '<div class="certificate_itext">' + $rootScope.VisualMenuContent.certificate_export + '</div>';
                certificatetext += '<div id="buttoncontainer_certificate">';
                certificatetext += '<button class="btn btn-primary printButton" onclick="printCertificate()">' + $rootScope.VisualMenuContent.print + '</button>';
                certificatetext += '<button class="btn btn-primary certificateClose" onclick="nameCancel()">' + $rootScope.VisualMenuContent.close + '</button>';
                certificatetext += '</div>';
                certificatetext += '<div class="certificate_note">' + $rootScope.VisualMenuContent.certificate_note + '</div>';
                certificatetext += '</div>';
                certificatetext += '</div>';
                $("#certificatecontainer").html(certificatetext);
            }
        }
        /* Show Certificate Logic Starts */
        // $rootScope.showcertificate = function () {
        //     updateAlert("en");
        //     if (navigator.onLine == true) {
        //         //var apptype = "scorm"; /* chnage apptype to scorm before uploading to lms standalone only for development */
        //         var learnerScore;
        //         var learnerName;
        //         var strStudentId;
        //         if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
        //             getLMSDATAVisualMenu();
        //             var dateString = getDateVisualMenu[3];
        //             learnerScore = Math.round(parent.SCORM_GetScore());
        //             learnerName = parent.SCORM_GetStudentName();
        //             // strStudentId = scormAdaptor_getstudentid();
        //         } else {
        //             var currentTime = new Date();
        //             var month = currentTime.getMonth() + 1;
        //             var day = currentTime.getDate();
        //             var year = currentTime.getFullYear();
        //             var dateString = day + '/' + month + '/' + year;
        //             learnerScore = "100"
        //             learnerName = "Default Name"
        //             strStudentId = "00001111"
        //         }

    //         $(".page-content").hide();
    //         setTimeout(function () {
    //             $("#certificatecontainer").show();
    //         }, 100);

    //         var strStudentName = "aaaaaaaaaa";
    //         if (strStudentName == "") {
    //             strStudentName = "Learner Name";
    //         }

    //         if ($rootScope.userRole == "nEmp") {
    //             $rootScope.certificateImg = $rootScope.VisualMenuContent.certificateimage_NTB;
    //         } else {
    //             $rootScope.certificateImg = $rootScope.VisualMenuContent.certificateimage_ETB;
    //         }
    //         var certificatetext = new String();

    //         certificatetext = '';


    //         certificatetext += '<div id="certificateArea">'
    //         certificatetext += '<div id="certificate">'

    //         certificatetext += '<div class="bgimage"><img src="' + $rootScope.certificateImg + '"/></div>';


    //         certificatetext += '<span class="certificateClose" onclick="nameCancel()">' + $rootScope.VisualMenuContent.closeText + '</span>';
    //         certificatetext += '<div class="name">' + learnerName + '</div>';
    //         certificatetext += '<div class="bankId">Bank Id: ' + strStudentId + '</div>';
    //         certificatetext += '<div class="score">' + learnerScore + "%" + '</div>';
    //         certificatetext += '<div class="date">' + dateString + '</div>';
    //         certificatetext += '<div id="buttoncontainer_certificate">';
    //         certificatetext += '<button class="btn btn-primary printButton" onclick="printCertificate()">' + $rootScope.VisualMenuContent.print + '</button>';
    //         certificatetext += '</div>';
    //         certificatetext += '</div>';
    //         certificatetext += '</div>';
    //         $("#certificatecontainer").html(certificatetext);
    //         $(".assessment-status").hide();
    //     }
    // }
    /* Show Certificate Logic Ends */

    GetConfigData = function() {
        return $http.get('../course_config.xml')
            .success(function(data) {
                $rootScope.CourseConfig = $.xml2json(data);
            });
    };
    $rootScope.selectedLanguage = function() {
        $rootScope.selectedLang = event.target.value;
        selectedLang = $rootScope.selectedLang
        $http.get('../course_content/' + $rootScope.selectedLang + '/langSelection.xml').
        then(function(response) {
            $rootScope.languageSelectContent = $.xml2json(response.data).root;
        }, function(response) {});

        $http.get('../course_content/' + $rootScope.selectedLang + '/coursemenu.xml').
        then(function(response) {
            if ($rootScope.CourseConfig.MenuDepth == 2) {
                $rootScope.CourseMenu = $.xml2json(response.data).root;
            } else {
                $rootScope.CourseMenu = $.xml2json(response.data).root;
            }


            $rootScope.topicTitle = $rootScope.CourseMenu.module[0].topics[$rootScope.currentTopic].name;
        });
    };



    GetConfigData().success(function(data) {
        data = $rootScope.CourseConfig.root;
        $rootScope.CourseConfig = {
            CourseName: data.CourseName,
            CourseBrand: data.CourseBrandName,
            BrandFont: data.CourseBrandFontSize,
            LogoPath: data.CourseBrandNameImg,
            AppType: data.courseSettings.appType,
            VisualMenu: data.courseSettings.visualMenu == 'true' ? true : false,
            SkipVisualmenu: data.courseSettings.skipVisualMenu == 'true' ? true : false,
            MenuDepth: parseInt(data.courseSettings.menuDepth),
            UIControls: data.UIControllers,
            ForceNavigation: data.courseSettings.forceNavigation == 'true' ? true : false,
            gamified: data.courseSettings.gamified == 'true' ? true : false,
            // gametype: data.courseSettings.gametype == 3 ? true : false,
            gametype: Number(data.courseSettings.gametype),
            encrypt: data.courseSettings.encrypt == 'true' ? true : false,
            HasAssessment: data.courseSettings.hasAssessment == 'true' ? true : false,
            AssessmentSection: parseInt(data.courseSettings.assessmentSection),
            TotalAssesmentQuestions: parseInt(data.courseSettings.totalQuestions),
            AvailableAssessmentQuestion: parseInt(data.courseSettings.availableQuestions),
            AvailablePreQuestions: parseInt(data.courseSettings.availableQuestions),
            HasPreAssessment: data.courseSettings.hasPreAssessment == 'true' ? true : false,
            PreAssessmentSection: parseInt(data.courseSettings.preAssessmentSection),
            maxtotalNuberofQuestionAttempt: parseInt(data.courseSettings.maxtotalNuberofQuestionAttempt),
            TotalPreQuestions: parseInt(data.courseSettings.totalQuestions),
            AvailablePreQuestions: parseInt(data.courseSettings.availableQuestions),
            IsPreRandomization: data.courseSettings.hasRandomization == 'true' ? true : false,
            IsPrePooling: data.courseSettings.hasPooling == 'true' ? true : false,
            IsRandomized: data.courseSettings.hasRandomization == 'true' ? true : false,
            HasPooling: data.courseSettings.hasPooling == 'true' ? true : false,
            vMenuAudio: data.courseSettings.vMenuAudio == 'true' ? true : false,
            HasPreAssessment: data.courseSettings.hasPreAssessment == 'true' ? true : false,
            PreAssessmentSection: parseInt(data.courseSettings.preAssessmentSection),
            // TotalPreQuestions: parseInt(data.courseSettings.totalPreQuestions),
            //AvailablePreQuestions: parseInt(data.courseSettings.availablePreQuestions),
            IsPreRandomization: data.courseSettings.hasPreRandomization == 'true' ? true : false,
            IsPrePooling: data.courseSettings.hasPrePooling == 'true' ? true : false,
            MasteryScore: parseInt(data.courseSettings.masteryScore),
            TotalAssessmentIntroPage: Number(data.courseSettings.totalAssessmentIntroPage),
            HasAssesmentIntro: data.courseSettings.hasAssessmentIntro == 'true' ? true : false,
            HasPreAssesmentIntro: data.courseSettings.hasPreAssessmentIntro == 'true' ? true : false,
            MaxAssesmentAttempt: parseInt(data.courseSettings.maxAssesmentAttempt),
            HasLangSelectionPage: data.courseSettings.multiLanguagePage == 'true' ? true : false,
            HasIntroPage: data.courseSettings.hasCourseIntro == 'true' ? true : false,
            HasRole: data.courseSettings.roleSelection == 'true' ? true : false,
            HasAudio: data.courseSettings.hasAudio == 'true' ? true : false,
            StartFirstTopic: data.courseSettings.startFirstTopic == 'true' ? true : false,
            PageCount: data.courseSettings.pageCountType,
            custom: data.courseSettings.custom,
            lmsType: Number(data.courseSettings.lmsType),
            easyNavigation: data.courseSettings.easyNavigation == 'true' ? true : false,
            dfndQ: data.courseSettings.totalDefinedQuestions.split(',').map(parseFloat),
            availDfndQ: data.courseSettings.availableDefinedQuestions.split(',').map(parseFloat),
            moduleDetails: data.module,
            caseStudyRandomization: data.courseSettings.caseStudyRandomization == 'true' ? true : false
        };

        init();
        if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
            loadPage();
            $rootScope.getScore = scormAdaptor_getscore();
        }
    });


    $rootScope.$watch('[]', function() {
        PreloaderService
            .preloadImages()
            .then(
                // == Preloaded images success resolve handler
                function handleResolve() {
                    $rootScope.isPreLoading = false;
                    $rootScope.isPreLoadSuccessful = true;
                },
                // == Preloaded images reject  handler
                function handleReject() {
                    $rootScope.isPreLoading = true;
                    $rootScope.isPreLoadSuccessful = false;
                },
                // == Preloaded images notify handler which is executed multiple times during preload
                function handleNotify(event) {
                    $rootScope.percentLoaded = event.percent;
                }
            );

    }, true);

    $stateProviderReference
        .state('/', {
            url: '/',
            templateUrl: $rootScope.deviceUrl + '/start.html',
            controller: 'Intro',
        })

    .state('course', {
        url: "/course",
        controller: 'Config',
        templateUrl: $rootScope.deviceUrl + '/home.html'
    })

    .state('role', {
        url: "/role",
        controller: 'Intro',
        templateUrl: $rootScope.deviceUrl + '/role.html'
    })

    .state('intro', {
        url: "/intro",
        controller: 'Intro',
        templateUrl: function() {
            return $rootScope.deviceUrl + '/ui/' + $rootScope.selectedLang + '/intro.html';
        }
    })

    .state('menu', {
        url: "/menu",
        controller: 'Config',
        templateUrl: '../html5/Views/visual_menu.html'
    })

    .state('course.pages', {
        url: "/page/:id",
        views: {
            'page-container': {
                controller: 'Config',
                templateUrl: function($stateParams) {
                    var ids = $stateParams.id.split("_");
                    if (!$rootScope.reloadAllPages) {
                        $rootScope.CourseContent = ""

                    }
                    $rootScope.reloadAllPages = false
                    $("#preloadericon").html('<img src="../course_images/pages/loader.gif">');
                    $timeout(function() { $("#preloadericon").html('') }, 500);
                    return ('../html5/Views/screens/' + $rootScope.selectedLang + '/m' + ids[0] + '/t' + ids[1] + '/s' + ids[2] + '.html');
                }
            }
        }
    });

    $urlRouterProviderReference.otherwise('/');
    $location.path('/page/:id').replace();


    function init() {
        // debugger
        //Get Course language Data in json format
        $http.get('../course_content/' + $rootScope.selectedLang + '/langSelection.xml').
        then(function(response) {
            $rootScope.languageSelectContent = $.xml2json(response.data).root;
        }, function(response) {});

        //Get Course Menu Data in json format
        $http.get('../course_content/' + $rootScope.selectedLang + '/coursemenu.xml').
        then(function(response) {

            $rootScope.CourseMenu = $.xml2json(response.data).root;
            $rootScope.CourseMenu = $.xml2json(response.data).root;
            $rootScope.topicTitle = $rootScope.CourseMenu.module[0].topics[$rootScope.currentTopic].name;
            $rootScope.pageStatusList = new Array($rootScope.CourseMenu.module.length);
            for (i = 0; i < $rootScope.CourseMenu.module.length; i++) {
                $rootScope.pageStatusList[i] = new Array($rootScope.CourseMenu.module[i].topics.length);
                for (j = 0; j < $rootScope.CourseMenu.module[i].topics.length; j++) {
                    if ($rootScope.CourseConfig.HasAssessment && j == $rootScope.CourseConfig.AssessmentSection - 1) {
                        $rootScope.pageStatusList[i][j] = new Array($rootScope.CourseConfig.AvailableAssessmentQuestion + 2);
                    } else if ($rootScope.CourseConfig.HasPreAssessment && j == $rootScope.CourseConfig.PreAssessmentSection - 1) {
                        $rootScope.pageStatusList[i][j] = new Array($rootScope.CourseConfig.AvailableAssessmentQuestion + 2);
                    } else
                        $rootScope.pageStatusList[i][j] = new Array($rootScope.CourseMenu.module[i].topics[j].pages.length);
                    for (k = 0; k < $rootScope.CourseMenu.module[i].topics[j].pages.length; k++) {
                        if ($rootScope.CourseConfig.HasAssessment && j == $rootScope.CourseConfig.AssessmentSection - 1) {

                            if (k < $rootScope.CourseConfig.AvailableAssessmentQuestion + $rootScope.CourseConfig.TotalAssessmentIntroPage + 1) {
                                $rootScope.pageStatusList[i][j][k] = new Array();
                                $rootScope.pageStatusList[i][j][k] = "0"
                            }
                            // for (l = 0; l < $rootScope.CourseConfig.AvailableAssessmentQuestion+2; l++) {
                            //     $rootScope.pageStatusList[i][j][k][l] = "0";
                            // }
                        } else if ($rootScope.CourseConfig.HasPreAssessment && j == $rootScope.CourseConfig.PreAssessmentSection - 1) {
                            if (k < $rootScope.CourseConfig.AvailableAssessmentQuestion + 2) {
                                $rootScope.pageStatusList[i][j][k] = new Array();
                                $rootScope.pageStatusList[i][j][k] = "0"
                            }
                        } else {
                            if (!$rootScope.CourseMenu.module[i].topics[j].pages[k].donotTrak) {
                                $rootScope.pageStatusList[i][j][k] = new Array();
                                $rootScope.pageStatusList[i][j][k] = "0";
                            }

                        }
                    }
                }

            }
            console.log($rootScope.pageStatusList)
            if (!$rootScope.CourseConfig.HasIntroPage && !$rootScope.CourseConfig.HasLangSelectionPage) {
                if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
                    $rootScope.getLMSData();
                } else {
                    if ($rootScope.CourseConfig.VisualMenu) {
                        $rootScope.$state.go('menu');
                    } else {
                        $rootScope.currentModule = 0;
                        $rootScope.currentTopic = 0;
                        $rootScope.currentPage = 0;
                        var page_id = "01_01_01"
                        $rootScope.$state.go('course.pages', { id: page_id });
                    }
                }
            }
        }, function(response) {});
        $rootScope.$on("$locationChangeStart", function(event, next, current) {
            $rootScope.CourseContent = "";
            // $rootScope.audioFile.src="";
            if (timerNext) {
                $timeout.cancel(timerNext);
                $("#gInstruct").hide(0);
            }
            $rootScope.popupToggle1 = false;
            $rootScope.popupToggle2 = false;
            $rootScope.CourseContent = "";
            $(".next").removeClass("done");
            $("#gInstruct").hide();
            $timeout(function() { $("#preloadericon").html('') }, 500);
            $rootScope.videoPopup = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].videoPopup;
            if ($rootScope.currentTopic == $rootScope.CourseConfig.AssessmentSection - 1 || $rootScope.currentTopic == $rootScope.CourseConfig.PreAssessmentSection - 1) {
                // if($rootScope.CourseConfig.gamified == true){
                //     if($rootScope.CourseConfig.gametype == true){
                var tURL = '../course_content/' + $rootScope.selectedLang + '/m' + $rootScope.pad($rootScope.currentModule + 1) + '/t' + $rootScope.pad($rootScope.currentTopic + 1) + '/p' + $rootScope.pad($rootScope.assesmentQuestionIndex[$rootScope.currentPage]) + '.xml';
                //     }
                // }
            } else {
                var tURL = '../course_content/' + $rootScope.selectedLang + '/m' + $rootScope.pad($rootScope.currentModule + 1) + '/t' + $rootScope.pad($rootScope.currentTopic + 1) + '/p' + $rootScope.pad($rootScope.currentPage + 1) + '.xml';
            }
            $http.get(tURL).
                // then(function (response) {
                // 	 $rootScope.isPageCompleted = false;
                // 	 $rootScope.CourseContent = $.xml2json(response.data).root.contents;

            // }, function (response) {
            // });
            then(function(response) {
                // 
                try {

                    window.atob(response.data);

                    var str2 = decodeURIComponent(escape(window.atob(response.data)));

                    $rootScope.CourseContent = $.xml2json(str2).root.contents;

                } catch (e) {

                    $rootScope.CourseContent = $.xml2json(response.data).root.contents;

                }
                var isCurrentBranching = $rootScope.CourseContent.branchingScreen == "true" || $rootScope.CourseContent.branchingScreen == true;
                $rootScope.headerValue2 = false
                $rootScope.headerValue3 = false
                    //console.log($rootScope.CourseContent)
                if (($rootScope.currentTopic == $rootScope.CourseConfig.AssessmentSection - 1 && $rootScope.currentPage > $rootScope.CourseConfig.TotalAssessmentIntroPage - 1 && $rootScope.currentPage < $rootScope.assesmentQuestionIndex.length - 1) || ($rootScope.currentTopic == $rootScope.CourseConfig.PreAssessmentSection - 1 && $rootScope.currentPage > 0 && $rootScope.currentPage < $rootScope.assesmentQuestionIndex.length - 1)) {
                    if ($rootScope.CourseContent.pageHeading != undefined) {
                        if ($rootScope.selectedLang != 'tc') {
                            $rootScope.CourseContent.pageHeading = $rootScope.CourseContent.pageHeading.split(' ')[0] + ($rootScope.currentPage - ($rootScope.CourseConfig.TotalAssessmentIntroPage - 1));
                        } else {
                            $rootScope.CourseContent.pageHeading = "第 " + ($rootScope.currentPage - ($rootScope.CourseConfig.TotalAssessmentIntroPage - 1)) + " 題";
                        }


                    }
                }
                if ($rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] != "1") {
                    if ($rootScope.CourseConfig.ForceNavigation)
                        $rootScope.isNextButtonDisabled = true;
                    else {
                        if ($rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection - 1 && $rootScope.currentTopic != $rootScope.CourseConfig.PreAssessmentSection - 1)
                            $rootScope.isNextButtonDisabled = false;
                    }
                    if ($rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection - 1 && $rootScope.currentTopic != $rootScope.CourseConfig.PreAssessmentSection - 1) {
                        $rootScope.isPrevButtonDisabled = false;
                    }
                } else {
                    if ($rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection - 1 && $rootScope.currentTopic != $rootScope.CourseConfig.PreAssessmentSection - 1) {
                        $rootScope.isNextButtonDisabled = false;
                    }
                }
                if ($rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection - 1 && $rootScope.currentTopic != $rootScope.CourseConfig.PreAssessmentSection - 1) {
                    $rootScope.isPrevButtonDisabled = false;
                }
                if (($rootScope.CourseContent.static == true || $rootScope.CourseContent.static == "true") && $location.path().indexOf("_") != -1 && $rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] == 1) {
                    $rootScope.markVisitedPage();
                } else if ($location.path().indexOf("_") != -1 && $rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] == 1 && $rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection - 1 && $rootScope.currentTopic + 1 != $rootScope.CourseConfig.PreAssessmentSection && !isCurrentBranching) {
                    // if ($rootScope.CourseContent.isnextbtndisabled != "true")
                    $rootScope.markVisitedPage();
                }

                /* if ($rootScope.currentModule == 0 && $rootScope.currentTopic == 0 && $rootScope.currentPage == 0) {
                    $rootScope.isPrevButtonDisabled = true;
                }
                else { */
                if (!$rootScope.CourseContent.branchingScreen && $rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection - 1 && $rootScope.currentTopic != $rootScope.CourseConfig.PreAssessmentSection - 1)
                    $rootScope.isPrevButtonDisabled = false;

                /* } */


                if ($rootScope.CourseContent.branchingScreen == "true" || $rootScope.CourseContent.branchingScreen == true) {
                    $rootScope.isNextButtonDisabled = true;
                    //$rootScope.isPrevButtonDisabled = true;
                }
                // debugger
                var assesmentSec = $rootScope.currentTopic == $rootScope.CourseConfig.AssessmentSection - 1;
                var preAssessmentSec = $rootScope.currentTopic <= $rootScope.CourseConfig.PreAssessmentSection - 1;
                // var notLastPage = $rootScope.currentPage < $rootScope.CourseMenu.module.topics[$rootScope.currentTopic].pages.length - 1;

                var notLastPage = $rootScope.currentPage < $rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic].length - 1;

                var notFirstPage = $rootScope.currentPage > $rootScope.CourseConfig.TotalAssessmentIntroPage - 1;
                if (assesmentSec || preAssessmentSec) {
                    if (notLastPage && notFirstPage){
                        $rootScope.disableresource = true;
                        $rootScope.disableMenu = true;
                    }
                    else
                    if (!preAssessmentSec){
                        $rootScope.disableresource = false;
                        $rootScope.disableMenu = false;
                    }
                    else{
                        $rootScope.disableresource = true;
                        $rootScope.disableMenu = true;
                    }
                } else {
                    if ($rootScope.CourseContent.menuDisable == "true") {
                        $rootScope.disableMenu = true;
                    } else {
                        $rootScope.disableMenu = false;
                    }
                }
                if ($rootScope.currentTopic == $rootScope.CourseConfig.PreAssessmentSection - 1) {
                    $rootScope.isNextButtonDisabled = true;
                }
                // if ($rootScope.currentTopic == 1 && $rootScope.currentPage == 0) {
                //     $timeout(function () {
                //         $rootScope.isPrevButtonDisabled = true;
                //     }, 500);

                // }
                //$rootScope.isPrevButtonDisabled = false;
                if ($rootScope.currentPageNumber == $rootScope.totalPages) {
                    $rootScope.isNextButtonDisabled = true;
                    $rootScope.isPrevButtonDisabled = true;
                }
                if ($rootScope.currentTopic == 0 && $rootScope.currentPage == 0) {
                    $rootScope.isPrevButtonDisabled = true;
                }
                if ($rootScope.CourseContent.disableNextPrev == "true" || $rootScope.CourseContent.disableNextPrev == true) {
                    $rootScope.isNextButtonDisabled = true;
                    $rootScope.isPrevButtonDisabled = true;
                }
                if ($rootScope.CourseContent.isnextbtndisabled == "true" || $rootScope.CourseContent.isnextbtndisabled == true) {
                    $rootScope.isNextButtonDisabled = true;
                    $("#gInstruct").hide();
                    $("#gInstruct").removeAttr("style")
                }
                if ($rootScope.CourseContent.disableNext == "true" || $rootScope.CourseContent.disableNext == true) {
                    $rootScope.isNextButtonDisabled = true;
                    // $rootScope.isPrevButtonDisabled = true;
                }

                if ($rootScope.CourseConfig.gamified == true) {
                    if ($rootScope.CourseConfig.gametype == 1) {
                        if ($rootScope.currentTopic == $rootScope.CourseConfig.AssessmentSection - 1) {
                            if ($rootScope.currentPage >= ($rootScope.CourseConfig.TotalAssessmentIntroPage - 1)) {
                                $rootScope.headerValue3 = true
                            } else {
                                $rootScope.headerValue3 = false
                            }
                        }
                    }
                }
                // disable first topic in the visualmenu
                if ($rootScope.CourseConfig.StartFirstTopic && $rootScope.currentTopic == 0) {
                    $rootScope.disableMenu = true;
                }


                $rootScope.PageNumFinished = $rootScope.currentPage;
                //console.log(tURL)
            }, function(response) {});
            getTotalPagesCount();
            getCurrentPagesCount();
        });

        var getTotalPagesCount = function() {
            var _totalPageCount = 0;
            if ($rootScope.CourseConfig.PageCount == "topicwise")
                $rootScope.totalPages = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages.length;
            else {
                if ($rootScope.CourseConfig.MenuDepth == 2) {
                    // debugger
                    if ($rootScope.CourseConfig.HasAssessment) {
                        for (var a = 0; a < $rootScope.CourseMenu.module.length; a++) {
                            for (var i = 0; i < $rootScope.CourseMenu.module[a].topics.length; i++) {
                                if (i == $rootScope.CourseConfig.AssessmentSection - 1) {
                                    _totalPageCount = _totalPageCount + $rootScope.CourseConfig.AvailableAssessmentQuestion + $rootScope.CourseConfig.TotalAssessmentIntroPage;
                                    if ($rootScope.CourseConfig.HasAssesmentIntro)
                                        _totalPageCount++;
                                } else {
                                    for (var j = 0; j < $rootScope.CourseMenu.module[a].topics[i].pages.length; j++) {
                                        _totalPageCount++;
                                    }
                                }
                            }
                        }
                    }
                }
                $rootScope.totalPages = getTotalPagenumber();
            }
        }

        var getCurrentPagesCount = function() {
            if ($rootScope.CourseConfig.PageCount == "topicwise")
                $rootScope.currentPageNumber = $rootScope.currentPage;
            else {
                var pageCounter = 0;
                for (var a = 0; a < $rootScope.CourseMenu.module.length; a++) {
                    for (var i = 0; i < $rootScope.CourseMenu.module[a].topics.length; i++) {
                        if ($rootScope.currentTopic == i) {
                            pageCounter += $rootScope.currentPage;
                            break;
                        } else {
                            pageCounter += $rootScope.CourseMenu.module[a].topics[i].pages.length;
                        }
                    }
                }
                pageCounter = pageCounter + 1;
                $rootScope.currentPageNumber = getCurrentPageNumber(pageCounter);
            }
        }

        function getTotalPagenumber() {

            var _totalPageCount = 0;
            for (var a = 0; a < $rootScope.CourseMenu.module.length; a++) {
                for (var i = 0; i < $rootScope.CourseMenu.module[a].topics.length; i++) {
                    for (var j = 0; j < $rootScope.CourseMenu.module[a].topics[i].pages.length; j++) {
                        if (!$rootScope.CourseMenu.module[a].topics[i].pages[j].branchingScreen)
                            _totalPageCount++;
                    }
                }

                var flag2 = 0;
                // if ($rootScope.CourseConfig.HasPooling ) {
                // if ($rootScope.CourseConfig.gamified != true) {

                // }

                if ($rootScope.userRole == "nEmp") {
                    if ($rootScope.CourseConfig.HasAssessment || $rootScope.CourseConfig.HasPreAssessment)
                        flag2 = ($rootScope.CourseConfig.TotalAssesmentQuestions - $rootScope.CourseConfig.AvailableAssessmentQuestion);
                } else {
                    if ($rootScope.CourseConfig.HasAssessment || $rootScope.CourseConfig.HasPreAssessment)
                        flag2 = ($rootScope.CourseConfig.TotalAssesmentQuestions - $rootScope.CourseConfig.AvailableAssessmentQuestion) * 2;
                }
            }

            // }
            _totalPageCount = _totalPageCount - flag2;
            return _totalPageCount;
        }

        function getCurrentPageNumber(_val) {
            var _totalPageCount = 0;
            var flag = 0;
            for (var a = 0; a < $rootScope.CourseMenu.module.length; a++) {
                for (var i = 0; i < $rootScope.CourseMenu.module[a].topics.length; i++) {
                    for (var j = 0; j < $rootScope.CourseMenu.module[a].topics[i].pages.length; j++) {
                        if (flag != _val) {

                            if (!$rootScope.CourseMenu.module[a].topics[i].pages[j].branchingScreen)
                                _totalPageCount++;
                        } else {
                            break;
                        }
                        flag++;
                    }
                }
            }
            if ($rootScope.CourseConfig.HasPreAssessment) {
                if ($rootScope.CourseConfig.AvailablePreQuestions + 4 < _totalPageCount) {
                    _totalPageCount = parseInt(_totalPageCount) - (parseInt($rootScope.CourseConfig.TotalPreQuestions) - parseInt($rootScope.CourseConfig.AvailablePreQuestions));
                    //return _totalPageCount;		
                }
            }
            var preSec = $rootScope.CourseConfig.PreAssessmentSection - 1;
            if ($rootScope.userRole == "nEmp" && $rootScope.currentTopic > preSec) {
                _totalPageCount = _totalPageCount - $rootScope.pageStatusList[$rootScope.currentModule][preSec].length;
            }
            return _totalPageCount;
        }


        $rootScope.$on("$locationChangeSuccess", function(event, next, current) {
            // 
            $rootScope.videoPopup = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].videoPopup;
            if ($location.path() != '/menu' && $location.path() != "'/'" && $rootScope.pageStatusList[$rootScope.currentModule].length > 0) {
                if ($rootScope.CourseConfig.HasAudio) {
                    //$rootScope.isAudio = $rootScope.CourseMenu.module.topics[$rootScope.currentTopic].pages[$rootScope.currentPage].isAudio;
                    if ($rootScope.isAudio == true) {
                        $rootScope.isSoundon = true;
                        //$rootScope.audioFile.currentTime = 0;
                        if ($rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection - 1)
                            $rootScope.audioFile.play();
                        else {
                            if (isNaN($rootScope.getScore) || $rootScope.getScore < $rootScope.CourseConfig.MasteryScore)
                                $rootScope.audioFile.play();
                        }
                    } else {
                        $(".audio-btn").addClass("disablePlay");
                    }
                }
            }
            if ($rootScope.videoPopup != undefined) {
                $rootScope.videoPopup = $rootScope.videoPopup.split(",")
                console.log($rootScope.videoPopup[0])
            }
            $rootScope.loadQuestion = function(id) {;
                $("#quetions_" + id).modal({
                    show: true,
                    backdrop: false
                })
                $("#quetions_" + id).data('bs.modal').options.backdrop = 'static';
                $(".help-btn").css('pointerEvents', 'none');
                $("#quetions_" + id + '_details').modal({
                    show: true,
                    backdrop: false
                });
                console.log($rootScope.videoFile);
                if ($rootScope.currentTopic != 0) {
                    $rootScope.isPrevButtonDisabled = true;
                }
                if ($rootScope.videoFile)
                    $rootScope.videoFile.pause();
                $(".footerPlayBtn i").removeClass("playBtn");
                $(".footerPlayBtn i").addClass("pauseBtn");
            }
            $rootScope.closeModal = function(id) {;
                $('#quetions_' + id).modal("hide");
                $rootScope.videoFile.play();
                $(".help-btn").css('pointerEvents', 'all');
                // alert(id)
                $rootScope.loadQuestion_Details(id);
            }
            $rootScope.cancel_queq_details = function(id) {

                $(".help-btn").css('pointerEvents', 'all');
                $('.progressBar,.menuSub, .footerPlayBtn i').css('pointerEvents', 'all');
                $('.ui-control').css({ 'pointerEvents': 'all', 'cursor': 'pointer' });
                $('#quetions_' + id + '_details').hide();
                $(".footerPlayBtn i").removeClass("pauseBtn");
                $(".footerPlayBtn i").addClass("playBtn");
                if (id == 3) {
                    $rootScope.markVisitedPage();
                }
                $rootScope.videoFile.play();
                // $rootScope.ClearVariables();
                // $rootScope.resetOptions();
            };
            $rootScope.isPreLoading = false;
            $rootScope.isPreLoadSuccessful = true;
            $rootScope.isRendered = true;
            $rootScope.percentLoaded = 0;
            $rootScope.disableAudio = false;
            if ($location.path() != '/menu' && $location.path() != "'/'" && $rootScope.pageStatusList[$rootScope.currentModule].length > 0) {
                $rootScope.menuDisplay = true;
                if ($rootScope.CourseConfig.HasAudio) {
                    if ($rootScope.isAudio == true) {
                        $rootScope.audioFile.play();
                    }
                }
            } else {
                $rootScope.menuDisplay = false;
            }
        });

        $rootScope.pad = function(n) {
            return (n < 10) ? ("0" + n) : n;
        }

        $rootScope.getdateString = function() {
            var currentTime = new Date();
            var month = currentTime.getMonth() + 1;
            var day = currentTime.getDate();
            var year = currentTime.getFullYear();
            $rootScope.dateString = month + "/" + day + "/" + year;

        }

        $rootScope.getDate = function() {
            var currentTime = new Date();
            var month = currentTime.getMonth() + 1;
            var day = currentTime.getDate();
            var year = currentTime.getFullYear();
            var Months = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
            var dateString = day + " " + Months[month - 1] + " " + year;
            return dateString;
        }

        $rootScope.getdateString();

        $rootScope.getUiAssests = function() {
            //Get Visual menu Content
            $http.get('../course_content/' + $rootScope.selectedLang + '/visualmenu.xml').
            then(function(response) {
                $rootScope.VisualMenuContent = $.xml2json(response.data).root;
            }, function(response) {});

            $http.get('../course_content/' + $rootScope.selectedLang + '/globalContent.xml').
            then(function(response) {
                $rootScope.gContent = $.xml2json(response.data).root;
            }, function(response) {});

            $http.get('../course_content/' + $rootScope.selectedLang + '/resources.xml').
            then(function(response) {
                // $rootScope.ResourceContent = response.data;
                $rootScope.ResourceContent = $.xml2json(response.data).root;
            }, function(response) {});

            $http.get('../course_content/' + $rootScope.selectedLang + '/help.xml').
            then(function(response) {
                $rootScope.HelpContent = $.xml2json(response.data).root;
            }, function(response) {});
            // $http.get('../course_content/' + $rootScope.selectedLang + '/coursemenu.xml').
            //     then(function (response) {
            //         debugger
            //         $rootScope.CourseMenu = $.xml2json(response.data).root;
            //     }, function (response) {
            //     });
            $http.get('../course_content/' + $rootScope.selectedLang + '/footer.xml').
            then(function(response) {
                $rootScope.footer = $.xml2json(response.data).root;
            }, function(response) {});
        };

        $rootScope.getUiAssests();

        // $rootScope.markVisitedPage = function () {
        //     $rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] = "1";

        //     if($rootScope.CourseContent.static == "true"){
        //         timer1 = $timeout(function(){
        //             $rootScope.isNextButtonDisabled = false;
        //             $rootScope.isPageCompleted = true;
        //             $("#gInstruct").fadeIn(300);                        
        //         },time);
        //     }else{
        //         timer1 = $timeout(function(){
        //             $("#gInstruct").fadeIn(700);    
        //             $rootScope.isNextButtonDisabled = false;
        //             $rootScope.isPageCompleted = true;
        //         },500);
        //     } 
        //     if ($rootScope.CourseContent.markNxtPageVisited == 'true') {
        //         $rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage + 1] = "1";
        //     }
        //     $rootScope.updateCourseProgress();
        // };


        $rootScope.markVisitedPage = function() {
            if ($rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] != "1") {
                $rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] = "1";
            }
            $rootScope.updateCourseProgress();
            var time = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].timer;

            var isStatic = ($rootScope.CourseContent.static == true || $rootScope.CourseContent.static == "true");
            // if(isLastPage !== 'true'){
            if (true) {
                if (isStatic) {
                    if (!time)
                        time = 600;
                    timerNext = $timeout(function() {
                        if (!$rootScope.CourseContent.branchingScreen) {
                            $rootScope.isNextButtonDisabled = false;
                            $rootScope.$apply();
                        }
                        $("#gInstruct").fadeIn(500);
                        $(".next").addClass("done");
                    }, time);
                } else {

                    if (!time)
                        time = 500;
                    timerNext = $timeout(function() {
                        if (!$rootScope.CourseContent.branchingScreen) {
                            $rootScope.isNextButtonDisabled = false;
                            $rootScope.$apply();
                        }
                        $("#gInstruct").fadeIn(500);
                        $(".next").addClass("done");
                    }, time);
                }
            }
            // }

            //console.log(timerNext+"==adding timer")






        };

        $rootScope.pageVisited = function(m, t, p) {
            if ($rootScope.CourseConfig.ForceNavigation) {
                if ($rootScope.pageStatusList[m][t][p] == "1")
                    return "enable-menu-list";
                else
                    return "disable-menu-list";
            }
        }
        $rootScope.topic3Completed = function() {

            for (var i = 0; i < $rootScope.pageStatusList[2].length; i++) {
                $rootScope.pageStatusList[2][i] = "1";
            }
        }



        $rootScope.$watch('assesmentScore', function(newIsOpenVal, oldIsOpenVal) {
            if (newIsOpenVal !== oldIsOpenVal) {
                if (newIsOpenVal != 0) {
                    if ($rootScope.CourseConfig.gamified == true) {
                        if ($rootScope.CourseConfig.gametype == 2) {
                            //alert('newIsOpenVal---> '+ newIsOpenVal +' oldIsOpenVal---> ' + oldIsOpenVal + ' currentPage---> ' + $rootScope.assesmentQuestionIndex[$rootScope.currentPage]);
                            $rootScope.scoreValue2 = $rootScope.scoreValue2 + Number($rootScope.CourseContent.point)
                            console.log($rootScope.scoreValue2)
                        }
                        if ($rootScope.CourseConfig.gametype == 1) {
                            $rootScope.scoreValue2 = $rootScope.scoreValue2 + $rootScope.scorepoints

                        }
                    } else {
                        for (var change_questionAttempted = 0; change_questionAttempted < $rootScope.questionFromTopic.length; change_questionAttempted += 1) {
                            if ($rootScope.questionFromTopic[change_questionAttempted].indexOf($rootScope.assesmentQuestionIndex[$rootScope.currentPage]) != -1) {
                                var indexReq = $rootScope.questionFromTopic[change_questionAttempted].indexOf($rootScope.assesmentQuestionIndex[$rootScope.currentPage]);
                                $rootScope.unlockTopic_ref[change_questionAttempted][indexReq] = '1';
                                // $rootScope.unlockTopic[change_questionAttempted][indexReq] = '1';
                                if ($rootScope.currentTopic == $rootScope.CourseConfig.PreAssessmentSection - 1)
                                // $rootScope.checkcomplatedtopic();
                                    break;
                            }
                        }
                    }


                }
                //console.log($rootScope.unlockTopic_ref)
                //debugger;
            }
        })

        /////////////////////////////////////////////////
        ///for opening links in new window
        /////////////////////////////////////////////////
        openLinkInNewWindow = function(link) {
            var myWindow1 = window.open(link, "myWindow", "width=1015, height=672,resizable=yes,scrollbars=yes");
        }


        $rootScope.viewedPage = function(m, t, p) {
            var currentPath = $location.path().split("/")[3];
            var cModule = currentPath.split("_")[0] - 1;
            var cTopic = currentPath.split("_")[1] - 1;
            var cPage = currentPath.split("_")[2] - 1;
            if ($rootScope.CourseContent.branchingScreen) {
                $("#0" + "_" + t + "_" + ($rootScope.CourseContent.branchingHomeScreen - 1)).addClass("current-page");
            }
            if (m == cModule && t == cTopic && p == cPage) {
                return "current-page"
            }
        }
        $rootScope.setUpAsmntArray = function() {

            }
            //Bootstrapp modal instaciate
        var ModalInstanceCtrl = function($scope, $modalInstance) {
            $scope.ok = function() {
                $modalInstance.close();
            };

            $scope.cancel = function() {
                if (navigator.onLine == false) {
                    $rootScope.checkInternet($rootScope.selectedLang);
                    return false;
                }
                $modalInstance.dismiss('cancel');
                if (!$rootScope.audioFile.ended) {
                    $rootScope.audioFile = document.getElementById('course-audio');
                    $rootScope.audioFile.play();
                }

                var videoTag = $("video")[0];
                if (videoTag && !videoTag.ended && videoTag.currentTime != 0) {
                    videoTag.play();
                }
            };

            $scope.resizeclass = function() {
                cssObj = {
                    "transform-origin": "top center",
                    "transform": "scale(" + $rootScope.scaleFactor + ")"

                }
                var isMobile_1 = /Android|iPad|iPhone|iPod/.test(navigator.userAgent) || (navigator.platform === 'MacIntel' && navigator.maxTouchPoints > 1)
                if (isMobile_1) {
                    // alert('here')
                    $timeout(function() {
                        // $(".modal").css(cssObj);
                        $(".modal").css({ 'width': '1000px', 'height': '650px' });
                        $(".modal").css(cssObj);
                    }, 100)
                }
            }
        };

        $rootScope.viewedTopic = function(m, t) {
            var currentPath = $location.path().split("/")[3];
            var cModule = currentPath.split("_")[0] - 1;
            var cTopic = currentPath.split("_")[1] - 1;
            var cPage = currentPath.split("_")[2] - 1;
            if (m == cModule && t == cTopic) {
                return "current-topic"
            }

        }

        //Event triggered on click of RESOURCE button
        $rootScope.loadResources = function() {

            if (navigator.onLine == false) {
                $rootScope.checkInternet($rootScope.selectedLang);
                return false;
            }
            $rootScope.audioFile = document.getElementById('course-audio');
            $rootScope.audioFile.pause();
            if (navigator.onLine) {
                var modalInstance = $modal.open({
                    animation: $rootScope.animationsEnabled,
                    templateUrl: '../html5/Views/ui/' + $rootScope.selectedLang + '/resource.html',
                    controller: ModalInstanceCtrl,
                    windowClass: "modal animated fadeIn _1",
                    backdrop: 'static',
                    keyboard: false

                });

                cssObj = {
                    "transform-origin": "top center",
                    "transform": "scale(" + $rootScope.scaleFactor + ")"

                }

                var isMobile_1 = /Android|iPhone|iPad|BlackBerry/i.test(navigator.userAgent);
                if (isMobile_1 == true) {
                    $timeout(function() {
                        // $(".modal").css(cssObj);

                        $(".modal-dialog").addClass('resourceAlign ')

                        $(".modal").css({ 'width': '1000px', 'height': '650px' });
                        $(".modal").css(cssObj);
                    }, 100)
                }
            }
            var videoTag = $("video")[0];
            if (videoTag) {
                videoTag.pause();
            }
        };


        //Event triggered on click of HELP button
        $rootScope.loadHelp = function() {
            $rootScope.checkInternet($rootScope.selectedLang);
            if (navigator.onLine) {
                var modalInstance = $modal.open({
                    animation: $rootScope.animationsEnabled,
                    templateUrl: '../html5/Views/ui/' + $rootScope.selectedLang + '/help.html',
                    controller: ModalInstanceCtrl,
                    windowClass: "modal animated fadeIn _1",
                    backdrop: 'static',
                    keyboard: false
                });


                cssObj = {
                    "transform-origin": "top center",
                    "transform": "scale(" + $rootScope.scaleFactor + ")"

                }
                var isMobile_1 = /Android|iPhone|iPad|BlackBerry/i.test(navigator.userAgent);
                if (isMobile_1 == true) {
                    $('.modal-backdrop').css('display', 'none')
                    $timeout(function() {
                        // $(".modal").css(cssObj);
                        $(".modal").css({ 'width': '1000px', 'height': '650px' });
                        $(".modal").css(cssObj);
                        // $('.modal-backdrop').css('display','none')

                    }, 100)
                } else


                    $('.modal-backdrop').find('body').css('overflow-y', 'hidden');

                // $rootScope.audioFile = document.getElementById('course-audio');
                // $rootScope.audioFile.pause();
                var videoTag = $("video")[0];
                if (videoTag) {
                    videoTag.pause();
                }
            }
        };

        //Event triggered on click of Menu button if Visual menu set to true
        $rootScope.loadVisualMenu = function() {
            var pageCompleted = false;
            $rootScope.checkInternet($rootScope.selectedLang);
            if (navigator.onLine == true) {
                $rootScope.audioFile = document.getElementById('course-audio');
                var srcMatch = $rootScope.audioFile.src;
                srcMatch = srcMatch.split('/');
                srcMatch = srcMatch[srcMatch.length - 1];
                if ($rootScope.CourseConfig.HasAudio && $rootScope.CourseConfig.vMenuAudio && srcMatch == "visual_menu.mp3") {
                    // alert("laod audio")
                    loadPages();
                } else {
                    // $rootScope.audioFile.src = "/#";
                    $rootScope.audioFile.removeAttribute('src')
                    $rootScope.audioFile.pause();
                    $rootScope.$state.go('menu');
                }

                function loadPages() {
                    $rootScope.$state.go('menu');
                    // $rootScope.audioFile.play();
                    if (pageCompletedfunction() == true) {
                        $rootScope.audioFile.pause();
                        $rootScope.disableAnimaation = true
                        $rootScope.audioFile.removeEventListener('loadeddata', loadPages);
                    } else {
                        $rootScope.audioFile.play();
                        $rootScope.audioFile.removeEventListener('loadeddata', loadPages);

                    }

                }
                $(".home-btn").addClass("btnDisabled");
                $(".course-header").css("pointer-events", "none");

                if ($rootScope.pageStatusList.join("").indexOf(1) == -1)
                    $rootScope.showResumeBtn = false;
                else {
                    $rootScope.showResumeBtn = true;
                    // if ($rootScope.currentTopic == $rootScope.CourseConfig.AssessmentSection - 2 && ($rootScope.isPassed[1] == 1)) {
                    //     $rootScope.showResumeBtn = false;
                    // } else {
                    //     $rootScope.showResumeBtn = true;
                    // }
                }
            }

            if ($rootScope.pageStatusList.indexOf('1') != -1) {
                $rootScope.audioFile.pause();
                // $rootScope.disableAnimaation=true
            }

            function pageCompletedfunction() {
                //
                for (var qi = 1; qi < $rootScope.pageStatusList.length; qi += 1) {
                    if ($rootScope.pageStatusList[qi].indexOf('1') != -1) {
                        pageCompleted = true;
                        break;
                    }
                }
                return pageCompleted
            }

            // if(pageCompleted == true){
            // 	$rootScope.audioFile.pause();
            // 	$rootScope.disableAnimaation=true

            // }
        };
    }

    $rootScope.reSetLMSData = function() {
        if ($rootScope.CourseConfig != undefined) {
            var _susData = "";
            if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
                doLMSSetValue("cmi.core.lesson_location", '');
                doLMSSetValue("cmi.suspend_data", _susData);
                scormAdaptor_commit();
            }
        }
    };
    $rootScope.AudioAutoPlay = function(pageType, pageId) {
        if ($rootScope.CourseConfig.HasAudio) {
            $rootScope.audioFile = document.getElementById('course-audio');
            $rootScope.audioFile.src = "#";
            var audioSrc;
            if (pageType == "page") {

                audioSrc = '../course_audio/' + $rootScope.selectedLang + '/m' + $rootScope.pad($rootScope.currentModule + 1) + '/t' + $rootScope.pad($rootScope.currentTopic + 1) + '/p' + $rootScope.pad($rootScope.currentPage + 1) + '.mp3';
            }
            if (pageType == "intro") {
                audioSrc = '../course_audio/intro/intro.mp3';
            }
            if (pageType == "menu") {
                audioSrc = '../course_audio/visual_menu/visual_menu.mp3';
            }
            $rootScope.isAudio = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].isAudio;
            $rootScope.isTranScript = toBool($rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].tranScript);
            $rootScope.donotTrack = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].donotTrack;
            $rootScope.isAudio = toBool($rootScope.isAudio);
            if ($rootScope.isAudio == true) {
                $rootScope.audioFile.src = audioSrc;
                $rootScope.audioFile.load();
                $rootScope.audioFile.addEventListener('loadeddata', $rootScope.LoadContent(pageType, pageId));
                $rootScope.audioFile.addEventListener('ended', $rootScope.AudioFinishedPlaying);
                // $rootScope.audioFile.onended = function () {
                //     if ($rootScope.CourseContent.audiocheck == 'true') {
                //         $rootScope.markVisitedPage();
                //     }
                // };
            } else {
                $rootScope.LoadContent(pageType, pageId)
            }

        } else {
            $rootScope.CourseContent = null
            $rootScope.LoadContent(pageType, pageId);
            $rootScope.isTranScript = toBool($rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].tranScript);
        }
    };

    $rootScope.LoadContent = function(pageType, pageId) {
        $("#preloadericon").html('<img src="../course_images/pages/loader.gif">');
        if ($rootScope.isAudio == "true")
            $rootScope.audioFile.removeEventListener('loadeddata', $rootScope.LoadContent, false);
        if (pageType == "page") {

            $rootScope.$state.go('course.pages', { id: pageId });
        }
        if (pageType == "intro") {
            $rootScope.$state.go('intro');
        }
        if (pageType == "menu") {
            $rootScope.loadVisualMenu();
        }
    };

    $rootScope.AudioFinishedPlaying = function() {
        if ($rootScope.CourseContent.static == true || $rootScope.CourseContent.static == "true") {
            $rootScope.markVisitedPage();
        }
        $rootScope.isAudio = false
        $rootScope.audioFile.removeEventListener('ended', $rootScope.AudioFinishedPlaying);
        $rootScope.$apply();
    }
    $rootScope.closeIframe = function() {
        $rootScope.showIframe = false;
        $rootScope.linkSrc = '';
    };

    $rootScope.printPdf = function() {
        var frm = document.getElementById("normalIframe").contentWindow;
        frm.focus(); // focus on contentWindow is needed on some ie versions
        frm.print();
    };

    $rootScope.EnableAssesment = function() {
        var st = false;
        for (var i = 0; i < $rootScope.pageStatusList[0].length - 1; i++) {
            if ($rootScope.pageStatusList[0][i].indexOf("0") == -1) {
                st = true
            } else {
                st = false
                break
            }
        }

        return st

    }


    $rootScope.topicPercentage = function(index, type) {
        var status = false
        var counter = 0
        if (type != 'result') {
            if ($rootScope.CourseMenu.module[0].topics[index].tracking == "false") {
                return false
            }
        }
        if ($rootScope.unlockTopic[index].length != 0) {
            if ($rootScope.unlockTopic[index].indexOf("1") != -1) {
                for (var i = 0; i <= $rootScope.unlockTopic[index].length - 1; i++) {
                    if ($rootScope.unlockTopic[index][i] == "1") {
                        counter = counter + 1
                    }
                }
                var per = (counter * 100) / Number($rootScope.unlockTopic[index].length)
                per = Math.round(per)
                if (per > 80) {
                    status = true
                } else {
                    status = false
                }
            } else {
                status = false
            }
        } else {
            status = false
        }
        return status
    }

    $rootScope.openPdfNewWindow = function() {
        myWindow = window.open($rootScope.linkSrc, "myWindow", "width=1015, height=672,resizable=yes,scrollbars=yes");
    };

    /////////////////////////////////////////////////
    ///LMS
    /////////////////////////////////////////////////


    $rootScope.updateCourseProgress = function() {
        var branching = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].branchingScreen;
        $rootScope.cPageData = $rootScope.pad($rootScope.currentModule + 1) + '|' + $rootScope.pad($rootScope.currentTopic + 1) + '|' + $rootScope.pad($rootScope.currentPage + 1);
        if (navigator.onLine == true) {
            $rootScope.setLMSData();
        }
        $rootScope.checkForCompletion();
    };

    $rootScope.checkInternet = function(val) {
        if (navigator.onLine == false) {
            updateAlert(val);
        }
    }

    $rootScope.setLMSData = function() {
        //debugger
        if ($rootScope.CourseConfig != undefined) {
            var _loctn = $rootScope.cPageData;
            var _psList = []
            for (var i = 0; i < $rootScope.pageStatusList.length; i++) {
                // for modules
                var x = $rootScope.pageStatusList[i]
                x = String(x.join(':'));
                _psList.push(x);
            }

            var _topicUnlock = $rootScope.unlockTopic;
            if ($rootScope.unlockTopic.length == 0) {
                _topicUnlock = '';
            } else {
                _topicUnlock = String(_topicUnlock.join('|'));
            }
            $rootScope.isPassed[7] = $rootScope.userRole
            var _susData = "course_progress=" + String(_psList.join('|')) + "%isPassed=" + $rootScope.isPassed + "%topicUnlockProgress=" + _topicUnlock;
            if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
                doLMSSetValue("cmi.core.lesson_location", String($rootScope.cPageData));
                doLMSSetValue("cmi.suspend_data", _susData);
                return scormAdaptor_commit();
            }
        }
    };

    $rootScope.setSuspend = function() {
        var _psList = $rootScope.pageStatusList;
        var _susData = "course_progress=" + String(_psList.join('|')) + "%isPassed=" + $rootScope.isPassed;
        if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
            doLMSSetValue("cmi.suspend_data", _susData);
            scormAdaptor_commit();
        }

    }

    $rootScope.getDate = function() {

    }





    $rootScope.createaAssesment = function() {
        $rootScope.assesmentQuestionIndex = [];
        if ($rootScope.CourseConfig.HasAssesmentIntro) {
            for (var i = 1; i <= $rootScope.CourseConfig.TotalAssessmentIntroPage; i++) {
                $rootScope.assesmentQuestionIndex.push(i);
            }

            $rootScope.getAsessmentQuestions($rootScope.CourseConfig.HasAssesmentIntro)
        } else {
            $rootScope.getAsessmentQuestions($rootScope.CourseConfig.HasAssesmentIntro)
        }
        $rootScope.assesmentQuestionIndex.push($rootScope.CourseConfig.TotalAssesmentQuestions + $rootScope.CourseConfig.TotalAssessmentIntroPage + 1);
        console.log($rootScope.assesmentQuestionIndex)


        $rootScope.refArray_randomn = []
        var numPush = $rootScope.CourseConfig.TotalAssessmentIntroPage;
        for (var creat_randomn = 0; creat_randomn < $rootScope.CourseConfig.dfndQ.length; creat_randomn += 1) {
            $rootScope.refArray_randomn[creat_randomn] = [];
            for (var pushToRandomnArray = 0; pushToRandomnArray < $rootScope.CourseConfig.dfndQ[creat_randomn]; pushToRandomnArray += 1) {
                numPush++
                $rootScope.refArray_randomn[creat_randomn].push(numPush)
            }
        }

        $rootScope.questionFromTopic = [];
        $rootScope.unlockTopic_ref = [];
        for (var question_topic = 1; question_topic < $rootScope.assesmentQuestionIndex.length - 1; question_topic += 1) {
            for (var question_topic_randomn = 0; question_topic_randomn < $rootScope.refArray_randomn.length; question_topic_randomn += 1) {
                if ($rootScope.refArray_randomn[question_topic_randomn].indexOf($rootScope.assesmentQuestionIndex[question_topic]) != -1) {
                    //debugger;
                    if ($rootScope.questionFromTopic[question_topic_randomn] == undefined) {
                        $rootScope.questionFromTopic[question_topic_randomn] = [];
                    }
                    if ($rootScope.unlockTopic_ref[question_topic_randomn] == undefined) {
                        $rootScope.unlockTopic_ref[question_topic_randomn] = [];
                    }
                    $rootScope.unlockTopic_ref[question_topic_randomn].push('0');
                    $rootScope.questionFromTopic[question_topic_randomn].push($rootScope.assesmentQuestionIndex[question_topic]);
                    break;
                }
            }
        }

        if ($rootScope.getScore >= $rootScope.CourseConfig.MasteryScore) {
            $rootScope.unlockTopic_ref = angular.copy($rootScope.unlockTopic_ref_passed);
        }
    }

    $timeout(function() {
        $rootScope.createaAssesment();
        $rootScope.caseStudyArray();
    }, 2000);

    $rootScope.caseStudyArray = function() {

        var t = $rootScope.casestudyArray
        if ($rootScope.CourseConfig.caseStudyRandomization) {
            $rootScope.casestudyArray = []
            shuffle(t)
            for (var i = 0; i <= 1; i++) {
                $rootScope.casestudyArray.push(t[i])
                $rootScope.caseStudycomplatedStatusstart2casestudy.push(0)
            }
        } else {
            for (var i = 0; i < 4; i++) {
                $rootScope.caseStudycomplatedStatusstart2casestudy.push(0)
            }
        }
    }

    // getAsessmentQuestions
    $rootScope.getAsessmentQuestions = function(hasIntro) {
        mergedArray = [];
        var pageNo = 0;
        if (hasIntro) pageNo = $rootScope.CourseConfig.TotalAssessmentIntroPage + 1;
        else pageNo = 1;
        for (var i = 0; i < $rootScope.CourseConfig.dfndQ.length; i++) {
            var ttoal = $rootScope.CourseConfig.dfndQ[i];
            var available = $rootScope.CourseConfig.availDfndQ[i];
            getRandomSlide(pageNo, ttoal, available, $rootScope.CourseConfig.IsRandomized);
            pageNo = pageNo + $rootScope.CourseConfig.dfndQ[i];
        }
        var a = mergedArray.join(',').split(',').map(parseFloat);
        if ($rootScope.CourseConfig.IsRandomized)
            a = shuffle(a);
        a.map(function(e) {
            $rootScope.assesmentQuestionIndex.push(e)
        });
        return a;
    }

    function getRandomSlide(pageNo, totalPages, availeble, isRandom) {
        var array = [];
        for (var l = pageNo; l < totalPages + pageNo; l++) {
            array.push(l)
        }
        if (isRandom)
            array = shuffle(array);
        array = array.slice(0, availeble);
        mergedArray.push(array)
        return array;
    }

    function shuffle(o) {
        for (var j, x, i = o.length; i; j = Math.floor((Math.random() * i)), x = o[--i], o[i] = o[j], o[j] = x) {}
        return o;
    }

    // getAsessmentQuestions end

    $rootScope.checkForCompletion = function() {
        var _count = 0;
        var _len = 0;
        if ($rootScope.CourseConfig != undefined) {
            if ($rootScope.CourseConfig.MenuDepth == 2) {
                for (var i = 0; i < $rootScope.pageStatusList.length; i++) {
                    _len += $rootScope.pageStatusList.length;
                    for (var j = 0; j < $rootScope.pageStatusList[i].length; j++) {
                        if ($rootScope.pageStatusList[i][j] == "1") _count++;
                    }
                }
            } else {
                for (var i = 0; i < $rootScope.pageStatusList.length; i++) {
                    for (var j = 0; j < $rootScope.pageStatusList[i].length; j++) {
                        _len += $rootScope.pageStatusList[i].length;
                        for (var k = 0; k < $rootScope.pageStatusList[j].length; k++) {
                            if ($rootScope.pageStatusList[j][k] == "1") _count++;
                        }
                    }
                }
            }
            _len += 1;
            if ($rootScope.pageStatusList.join('').indexOf("0") == -1) {

                scormAdaptor_complete();
            }
        }
    }
}]);


function updateAlert(val) {
    if (navigator.onLine == false) {
        if (val == "en") {
            alert("Retrieval of data failed, this may be due to\n\n\u2022Failure in internet connection\n\u2022Failure in VPN connection\n\u2022Session Timeout\n\n\Please check all the above and re-take the assessment/course for successful completion\n\n\Note: Bookmark will help you to go to the last page you visited.");
        }

        if (val == "sc") {
            alert("数据检索失败，这可能是因为\n\n\u2022互联网连接失败\n\u2022VPN连接失败\n\u2022会话超时\n\n\请检查上述因素并重新参加测验/课程，以成功完成学习。\n\n\注意： 书签将帮助你前往你访问的最后一页。");
        }

        if (val == "in") {
            alert("Penarikan data gagal, ini mungkin disebabkan karena\n\n\u2022Kegagalan koneksi internet\n\u2022Kegagalan koneksi VPN\n\u2022Habis Waktu Sesi\n\n\Harap periksa seluruh hal tersebut di atas dan ulangi penilaian/pelatihan agar berhasil menyelesaikan.\n\n\Catatan: Penanda akan membantu Anda untuk membuka halaman terakhir yang Anda kunjungi.");
        }

        if (val == "kr") {
            alert("데이터를 불러 오는 데 실패 했다면, 다음의 이유로 추정됩니다.\n\n\u2022인터넷 연결 상태가 원활하지 않았기 때문에\n\u2022VPN 연결 상태가 원활하지 않았기 때문에\n\u2022 세션 시간이 종료되어서\n\n\상기 사항을 모두 확인 하신 다음, 평가/코스를 다시 완료해 주시기 바랍니다.\n\n\참고: 북마크 기능으로 마지막으로 방문했던 페이지를 쉽게 찾으실 수 있습니다.");
        }

        if (val == "tc") {
            alert("擷取資料錯誤，可能是因為以下原因\n\n\u2022網際網路連線失敗\n\u2022VPN 連線失敗\n\u2022工作階段逾時\n\n\請檢查以上原因並重新進行評估/課程。\n\n\Note: 注意事項： 書籤功能將協助您前往上次瀏覽的頁面。");
        }
        if (val == "th") {
            alert("การกู้คืนข้อมูลล้มเหลว สาเหตุอาจเป็นเพราะ\n\n\u2022การเชื่อมต่ออินเทอร์เน็ตล้มเหลว\n\u2022การเชื่อมต่อ VPN ล้มเหลว\n\u2022หมดเวลา\n\n\กรุณาตรวจสอบสาเหตุทั้งหมดข้างต้นแล้วทำการประเมิน/เรียนหลักสูตรใหม่อีกครั้งเพื่อให้ผ่านหลักสูตรนี้\n\n\หมายเหตุ: การบุ๊กมาร์คจะช่วยให้คุณไปยังหน้าล่าสุดได้ง่ายขึ้น");
        }
    }

}

function exitcourse() {
    window.close();
    top.close();
    window.self.close();
    window.top.close();
    // clearInterval(myVar);
    countMouse = 0;
}


// * Internet Connection Alert Ends */
var getsuspendDataVisual;
var getDateVisualMenu;

function getLMSDATAVisualMenu() {
    getsuspendDataVisual = scormAdaptor_getsuspenddata();
    getParsedSuspendDataVisual();


}



function getParsedSuspendDataVisual() {

    var tmp = getsuspendDataVisual.split("&");
    if (tmp.length > 1) tmp = tmp[1].split('%isPassed=');
    else tmp = tmp[0].split('%isPassed=');
    if (tmp.length >= 1) getDateVisualMenu = tmp[1].split(',');
    tmp = tmp[0].split("=");
    var suspendData = {};
    suspendData[tmp[0]] = tmp[1];
    return (suspendData);

};